<?php
///////////////////////////////////////////////////////////////////////////
require_once 'utils.php';

class Cursor
{

	    private $m_feed;
	    private $m_feed_url;
	    private $m_items_count;
        private $m_last_ref;

    ///////////////////////////////////////////////////////////////////////

    public function __construct($media_url)
    {
        if ($media_url === 'main_menu:fav')
            $this->m_feed_url = 'main_menu:fav';
        else
            HD::decode_user_data($media_url, $media_str, $this->m_feed_url);

        $this->m_items_count = 0;
        $this->m_feed = 0;
        $this->m_last_ref = "";
    }

    private function parse_page($url)
    {
        $api = HOST_API_URL;
        
        $items = array();

        $doc = HD::http_get_document($url);
		$videos = explode('id="clip_', $doc);
        unset($videos[0]);
        $videos = array_values($videos);

        foreach($videos as $video)
        {	
			
            $tmp = explode('"', $video);
			$season_ref = $tmp[0];
            
			$tmp = explode('<img src="', $video);
            if (count($tmp) < 2)
                continue;
            $season_image = str_remove_spec(strstr($tmp[1], '"', true));
            
            $tmp = explode('title="', $video);
            if (count($tmp) < 2)
                continue;
            $season_title = str_remove_spec(strstr($tmp[1], '"', true));

            ////////hd_print("--->>> season_ref: $season_ref");
            ////////hd_print("--->>> season_title: $season_title");
            ////////hd_print("--->>> season_image: $season_image");
            
            array_push
            (
                $items,
                HD::encode_user_data
                (
                    array
                    (
                        'video_id' => $season_ref,
                        'season_title' => $season_title,
                        'season_ref' => $season_ref,
                        'season_image' => $season_image,
                        'is_has_new' => false
                    )
                )
            );
            ++$this->m_items_count;
        }
        
        return $items;
    }
	
    private function parse_subcategory()
    {
        ////////hd_print("--> parse subcategory: started...");
        $subcategory = $this->m_feed_url;
        $ref = $subcategory->subcategory_ref;
        $api = HOST_API_URL;
        
        $url = $ref;
        //////hd_print("url--->>>: $url");
		$tmp = explode('/sort', $url);
			 $url1=$tmp[1];
			 $url2=$tmp[0];	
			////hd_print("url1--->>>: $url1");
			////hd_print("url2--->>>: $url2");
        if ($this->m_feed > 0)
			$url = $url2 ."/page:".($this->m_feed + 1) . "/sort" . $url1 ;
			//////hd_print("url--->>>: $url");
        return $this->parse_page($url);
    }

    ///////////////////////////////////////////////////////////////////////
    private function parse_search_result($search,$video_sorting)
    {
       // //////hd_print("--> parse search result: started... $search");
        $api = HOST_API_URL;
		
		if ($video_sorting == "0")
			{
			$sort_path ='/sort:relevant/format:thumbnail';
			}
		elseif ($video_sorting == "1")
			{
			 $sort_path ='/sort:date/format:thumbnail';
			}
		elseif ($video_sorting == "2")
			{
			$sort_path ='/sort:alphabetical/format:thumbnail';
			}
		elseif ($video_sorting == "3")
			{
			 $sort_path ='/sort:plays/format:thumbnail';
			}
		elseif ($video_sorting == "4")
			{
			 $sort_path ='/sort:likes/format:thumbnail';
			}
		elseif ($video_sorting == "5")
			{
			 $sort_path ='/sort:comments/format:thumbnail';
			}
		elseif ($video_sorting == "6")
			{
			$sort_path ='/sort:duration/format:thumbnail';
			}
        
		$url = "http://vimeo.com/search" . $sort_path . "?q=" . $search;
		$tmp = explode('/sort', $url);
			 $url1=$tmp[1];
			 $url2=$tmp[0];	
		////hd_print("url1--->>>: $url1");
		////hd_print("url2--->>>: $url2");
        if ($this->m_feed > 0)
			$url = $url2 ."/page:".($this->m_feed + 1) . "/sort" . $url1 ;
		////hd_print("url--->>>: $url");
        return $this->parse_page($url);
    }
    ///////////////////////////////////////////////////////////////////////

    private function get_next_fav(&$plugin_cookies)
    {
      //  //////hd_print("--> get favorites: started... $this->m_feed");
        
        $fav_items = isset($plugin_cookies->fav_items) ? $plugin_cookies->fav_items : '';
        
        $ref = "";
        
        $n = 0;
        foreach (ListUtil::string_to_list($fav_items) as $item)
        {
            if ($item == "")
                continue;
            
            if ($n == $this->m_feed)
            {
                $ref = $item;
            }

            ++$n;
            
        }

        if ($ref == "")
            return false;
        
        $items = array();

        $c = VideoCache::get($ref);
        if (!is_null($c))
        {
            array_push
            (
                $items,
                $c
            );

            ++$this->m_items_count;

            return $items;
            
        }

        $api = HOST_API_URL;
        
        $url = 'http://vimeo.com/api/v2/video/'.$ref.'.xml';
        
        $doc = HD::http_get_document($url);
        $info_block = $doc;      
        // title
        $tmp = explode("<title>", $info_block);
        $season_title = str_remove_spec(strstr($tmp[1], "<", true));

        // image
        $tmp = explode('<thumbnail_large>', $info_block);
        $season_image = str_remove_spec(strstr($tmp[1], '<', true));

        $series_block = '';
        $tmp = strstr($doc, '<select size="1" name="fileId" onchange="this.form. submit();">');
        
        $is_has_new = false;

        if ($tmp && isset($plugin_cookies->$ref))
        {
            $series_block = strstr($tmp, '</select>', true);
            $videos = explode('value="', $series_block);
            unset($videos[0]);
            $videos = array_values($videos);

            foreach($videos as $video)
            {
                $fileid = strstr($video, '"', true);
                $episode_ref = $url . "?fileId=$fileid";
                
            //    //////hd_print("--->>> episode_ref: $episode_ref");

                if (isset($plugin_cookies->$ref))
                    if (!ListUtil::is_in_list($plugin_cookies->$ref, $episode_ref))
                        $is_has_new = true;
                            
                if ($is_has_new)
                    break;
            }
        }
        
        array_push
        (
            $items,
            HD::encode_user_data
            (
                array
                (
                    'video_id' => $ref,
                    'season_title' => $season_title,
                    'season_ref' => $ref,
                    'season_image' => $season_image,
                    'is_has_new' => $is_has_new
                )
            )
        );

        ++$this->m_items_count;

        return $items;
    }
    ///////////////////////////////////////////////////////////////////////

    public function next_chunk($plugin_cookies)
    {
	    ////////hd_print("--> next_chunk(): started...");

	    $items = array();

        if ($this->m_feed_url === 'main_menu:fav')
        {
            ////////hd_print("--> parse favorites: started...");
            
            $items = $this->get_next_fav($plugin_cookies);
            ++$this->m_feed;

            if ($items === false)
                return false;
            
            return count($items) > 0 ? $items : false;
        }
	    if (HD::has_attribute($this->m_feed_url, 'ser_feed'))
	    {
		   // //////hd_print("--> search: started...");
            
		    $search_text = $this->m_feed_url->ser_feed;
			$video_sorting = isset($plugin_cookies->video_sorting) ? $plugin_cookies->video_sorting : 1;
			$items = $this->parse_search_result($search_text, $video_sorting);
            ++$this->m_feed;
            
		 //   //////hd_print("--> search for: " . $search_text);

            if ($items === false)
                return false;
                
            ////////hd_print("--> next_chunk(): found " . count($items) . " items.");
            return count($items) > 0 ? $items : false;
	    }
        else if (HD::has_attribute($this->m_feed_url, 'subcategory_ref'))
        {
           $items = $this->parse_subcategory();
            ++$this->m_feed;

            if ($items === false)
                return false;
                
            ////////hd_print("--> next_chunk(): found " . count($items) . " items.");
            return count($items) > 0 ? $items : false;
        }

        return false;
    }
}

///////////////////////////////////////////////////////////////////////////
?>
